// To test in serial monitor , take comments out to see the output.
// Need to send R00000G0S000 
int Speed;
int maxSpeed = 300;
int Gear;
int Rpm;
int RpmLeds;
int RpmMax = 8000;
//int Water;
//int Oil;
//int Fuel;
//int EngineOverHeat;
//int BrakeOverHeat;
//int TireDamage;
//int ShiftUp;
//int ShiftDown;
//int PartsDetached;
//int InPits;
//int YellowFlag;
//int Sector1Flag;
//int Sector2Flag;
//int Sector3Flag;
int valwsv = 0;
int buttonCheck = 1;
int bufferArray[12];

#include <Servo.h>
#include <TM1638.h> 

Servo WindServo;


TM1638 module(5, 4, 3);
void setup(){

  Serial.begin(57600);
// initialize the screen:
    module.clearDisplay();              //clears the display 
    String name = "DASH";           //sets a custom Label
    module.setDisplayToString(name);    //prints the Label
    delay(3000);                        //small delay 3 sec
    module.clearDisplay();              //clears the display
    
    // setup servo please change pin number if not correct, set to Pin 9
    WindServo.attach(9);
    
}

void loop(){ 
  //****************************** READ DATA FROM SERIAL ******************************

  if (Serial.available() == 12)  {    //if 24 bits available in the Serial buffer...
        
        int i;
        for (i=0; i<12; i=i+1) {       // read and label each byte.
         bufferArray[i] = Serial.read();
         }
        
         if (bufferArray[0]  == 'R'){
           unsigned int rpmSmTools = ((bufferArray[1]-48)*10000) + ((bufferArray[2]-48)*1000) + // Take values 1-5.
                               ((bufferArray[3]-48) *100) + ((bufferArray[4]-48)*10) + (bufferArray[5]-48);
         //  Serial.print("You have set the Rpm to a Value of:");     
          // Serial.println(rpmSmTools);
          Rpm = rpmSmTools;
                 }
         if (bufferArray[6] == 'G'){
           unsigned int gearSmTools = ((bufferArray[7]-48)*1);
            Gear = gearSmTools;
            //Serial.print("You have set the Gear to a Value of:");     
            //Serial.println(gearSmTools);
        }
         if (bufferArray[8]  == 'S'){
           unsigned int speedSmTools = ((bufferArray[9]-48)*100) + ((bufferArray[10]-48)*10) + (bufferArray[11]-48); // Take values 1-5.
            Speed = speedSmTools;                     
           //Serial.print("You have set the Speed to a Value of:");     
           //Serial.println(speedSmTools);
             
            }
           //   if (bufferArray[12]  == 'O'){
           //unsigned int oilSmTools = ((bufferArray[13]-48)*100) + ((bufferArray[14]-48)*10) + (bufferArray[15]-48); // Take values 1-5.
                                 
           //Serial.print("You have set the Oil to a Value of:");     
           //Serial.println(oilSmTools);
           
   //           }
  //if (bufferArray[16]  == 'W'){
    //       unsigned int waterSmTools = ((bufferArray[17]-48)*100) + ((bufferArray[18]-48)*10) + (bufferArray[19]-48); // Take values 1-5.
                                 
           //Serial.print("You have set the Water to a Value of:");     
           //Serial.println(waterSmTools);
 // }
//if (bufferArray[20]  == 'F'){
  //         unsigned int FuelSmTools = ((bufferArray[21]-48)*100) + ((bufferArray[22]-48)*10) + (bufferArray[23]-48); // Take values 1-5.
                                 
           //Serial.print("You have set the Fuel to a Value of:");     
           //Serial.println(FuelSmTools);
 // }
//if (bufferArray[24]  == 'L'){
  //           EngineOverHeat = bufferArray[25];
    //         BrakeOverHeat = bufferArray[26];
      //       TireDamage =  bufferArray[27];
        //     ShiftUp = bufferArray[28];
          //   ShiftDown = bufferArray[29];
           //  PartsDetached =  bufferArray[30];
          //   InPits = bufferArray[31];
          //   YellowFlag = bufferArray[32];
           //  Sector1Flag = bufferArray[33];
            // Sector2Flag = bufferArray[34];
            // Sector3Flag = bufferArray[35];
          // Serial.print("You have set the lights to a Value of:");     
           //Serial.println( bufferArray[25]-48);
           //Serial.println( bufferArray[26]-48);
           //Serial.println( bufferArray[27]-48);
           //Serial.println( bufferArray[28]-48);
           //Serial.println( bufferArray[29]-48);
           //Serial.println( bufferArray[30]-48);
           //Serial.println( bufferArray[31]-48);
           //Serial.println( bufferArray[32]-48);
           //Serial.println( bufferArray[33]-48);
           //Serial.println( bufferArray[34]-48);
           //Serial.println( bufferArray[35]-48);
  //}
CheckButtons();
UpdateLCD();
UpdateWSV();
}
}

void UpdateLCD() {
  
       if (buttonCheck == 1){
         RpmLeds = map(Rpm, 500,RpmMax ,1 ,8);
         if (RpmLeds == 1) { module.setLEDs(0b00000001 | 0b00000000<< 8);} 
         if (RpmLeds == 2) { module.setLEDs(0b00000011 | 0b00000000<< 8);}
         if (RpmLeds == 3) { module.setLEDs(0b00000111 | 0b00000000<< 8);}  
         if (RpmLeds == 4) { module.setLEDs(0b00001111 | 0b00000000<< 8);}
         if (RpmLeds == 5){ module.setLEDs(0b00011111 | 0b00000000<< 8);}
         if (RpmLeds == 6){ module.setLEDs(0b00011111 | 0b00100000<< 8);}
         if (RpmLeds == 7){ module.setLEDs(0b00011111 | 0b01100000<< 8);}
         if (RpmLeds == 8){ module.setLEDs(0b00011111 | 0b11100000<< 8);}
       
         module.setDisplayToDecNumber(Speed, 0, false);  //displays numerical the Speed 
       //module.setDisplayToDecNumber(Rpm, 0, false);  //displays numerical the rpm
       
         if (Gear == 9) {char* name = "r"; module.setDisplayToString(name,0);}//r- little r
         if (Gear == 0) {char* name = "n"; module.setDisplayToString(name,0);} //n - little n
         if (Gear == 1) {module.setDisplayDigit(1, 0, false);}
         if (Gear == 2) {module.setDisplayDigit(2, 0, false);}
         if (Gear == 3) {module.setDisplayDigit(3, 0, false);}
         if (Gear == 4) {module.setDisplayDigit(4, 0, false);}
         if (Gear == 5) {module.setDisplayDigit(5, 0, false);}
         if (Gear == 6) {module.setDisplayDigit(6, 0, false);} 
         if (Gear == 7) {module.setDisplayDigit(7, 0, false);}
         }
if (buttonCheck == 2){
         
         RpmLeds = map(Rpm, 500, RpmMax,1 ,8);
         if (RpmLeds == 1) { module.setLEDs(0b00000001 | 0b00000000<< 8);} 
         if (RpmLeds == 2) { module.setLEDs(0b00000011 | 0b00000000<< 8);}
         if (RpmLeds == 3) { module.setLEDs(0b00000111 | 0b00000000<< 8);}  
         if (RpmLeds == 4) { module.setLEDs(0b00001111 | 0b00000000<< 8);}
         if (RpmLeds == 5){ module.setLEDs(0b00011111 | 0b00000000<< 8);}
         if (RpmLeds == 6){ module.setLEDs(0b00011111 | 0b00100000<< 8);}
         if (RpmLeds == 7){ module.setLEDs(0b00011111 | 0b01100000<< 8);}
         if (RpmLeds == 8){ module.setLEDs(0b00011111 | 0b11100000<< 8);}
       
         //module.setDisplayToDecNumber(Speed, 0, false);  //displays numerical the Speed 
         module.setDisplayToDecNumber(Rpm, 0, false);  //displays numerical the rpm
       
         if (Gear == 9) {char* name = "r"; module.setDisplayToString(name,0);}//r- little r
         if (Gear == 0) {char* name = "n"; module.setDisplayToString(name,0);} //n - little n
         if (Gear == 1) {module.setDisplayDigit(1, 0, false);}
         if (Gear == 2) {module.setDisplayDigit(2, 0, false);}
         if (Gear == 3) {module.setDisplayDigit(3, 0, false);}
         if (Gear == 4) {module.setDisplayDigit(4, 0, false);}
         if (Gear == 5) {module.setDisplayDigit(5, 0, false);}
         if (Gear == 6) {module.setDisplayDigit(6, 0, false);} 
         if (Gear == 7) {module.setDisplayDigit(7, 0, false);}
         }
}
void CheckButtons(){
 if (module.getButtons() == 0b00000001){buttonCheck = 1;}
 if (module.getButtons() == 0b00000010){buttonCheck = 2;}
 if (module.getButtons() == 0b00000100){RpmMax = Rpm;}
  }
  
 void UpdateWSV(){
   if (Speed > maxSpeed){maxSpeed = Speed;}
   valwsv = map(Speed, 0 , maxSpeed, 0 , 255);
   WindServo.write(valwsv);
 }
